/* 	$Id: menus.c,v 1.3 2000/01/08 20:01:06 ben Exp $	 */

#include <config.h>

#include "yamt.h"
#include "menus.h"
#include "properties.h"
#include "page_edit.h"


static GnomeUIInfo file_menu [] = {
  GNOMEUIINFO_MENU_OPEN_ITEM (edit_file_select, NULL),
  GNOMEUIINFO_MENU_SAVE_ITEM (edit_file_save, NULL),
  GNOMEUIINFO_SEPARATOR,
  GNOMEUIINFO_MENU_EXIT_ITEM (yamt_exit, NULL),
  GNOMEUIINFO_END
};

static GnomeUIInfo edit_menu [] = {
  GNOMEUIINFO_MENU_PROPERTIES_ITEM(properties, NULL),
  GNOMEUIINFO_END
};

static GnomeUIInfo help_menu[] = {
/*   GNOMEUIINFO_MENU_HELP_ITEM (help_cb, NULL), */
  GNOMEUIINFO_MENU_ABOUT_ITEM (about_cb, NULL),
  GNOMEUIINFO_END
};

static GnomeUIInfo menu[] = {
  GNOMEUIINFO_MENU_FILE_TREE(file_menu),
  GNOMEUIINFO_MENU_EDIT_TREE(edit_menu),
  GNOMEUIINFO_MENU_HELP_TREE(help_menu),
  GNOMEUIINFO_END
};



void install_statusbar(GtkWidget *app)
{
  GtkWidget *status;
  
  status = gnome_appbar_new( FALSE, TRUE, GNOME_PREFERENCES_USER); 
  gnome_app_set_statusbar( GNOME_APP (app), status);
}


void install_menus(GtkWidget *app)
{
  gnome_app_create_menus( GNOME_APP (app), menu);
  gnome_app_install_menu_hints( GNOME_APP (app), menu);
}


static void nothing_cb (GtkWidget* widget, gpointer data)
{
    GtkWidget* dialog;
    GtkWidget* app;

    app = (GtkWidget*) data;

    dialog = gnome_ok_dialog_parented(
      _("Function is not implemented!"), GTK_WINDOW(app));
}


static void help_cb (GtkWidget* widget, gpointer data)
{
  GtkWidget *window;
  GtkWidget *frame;
  GtkWidget *hbox;
  GtkWidget *button;
  GtkWidget *text;
  GtkWidget *vscroll;

  char *help_text=
    "I think mostly everything should be self explaining,\n"
    "but if you have any problems please read the files\n"
    "that came with this program.\n"
    "\n"
    "If there still are any questions visit the project\n" 
    "homepage at http://yamt.sourceforge.net\n"
    "or mail to <BenediktRoth@users.sourceforge.net>\n";
  
  window = gtk_dialog_new();
  gtk_container_set_border_width( GTK_CONTAINER (window), 3);
  gtk_window_position( GTK_WINDOW (window), GTK_WIN_POS_MOUSE);
  gtk_window_set_title( GTK_WINDOW (window), "YAMT - Help");

  
  frame = gtk_frame_new(NULL);
  gtk_box_pack_start( GTK_BOX (GTK_DIALOG (window)->vbox),
                       frame, TRUE, TRUE, 0);
  gtk_frame_set_label( GTK_FRAME (frame), "Help");
  gtk_container_set_border_width( GTK_CONTAINER (frame), 5);
  gtk_widget_show(frame);

  hbox = gtk_hbox_new( FALSE, 0);
  gtk_container_add( GTK_CONTAINER (frame), hbox);
  gtk_widget_show(hbox);

  text = gtk_text_new( NULL, NULL);
  gtk_widget_show(text);
  gtk_text_set_editable( GTK_TEXT (text), FALSE);
  gtk_text_set_word_wrap( GTK_TEXT (text), FALSE);

  gtk_widget_set_usize( GTK_WIDGET (text), 300, 120);
  gtk_box_pack_start( GTK_BOX (hbox), text,
                      TRUE, FALSE, 0);
  gtk_widget_show( text);

  vscroll = gtk_vscrollbar_new( GTK_TEXT( text )->vadj );
  gtk_box_pack_start( GTK_BOX (hbox), vscroll,
                      TRUE, FALSE, 0);

  gtk_widget_show(vscroll);

  gtk_text_insert( GTK_TEXT (text), NULL, NULL , NULL, help_text, strlen(help_text) );
  gtk_widget_realize( text);


  button = gtk_button_new_with_label("OK");
  gtk_signal_connect( GTK_OBJECT (button), "clicked",
                      GTK_SIGNAL_FUNC (destroy), window );
  gtk_box_pack_start( GTK_BOX (GTK_DIALOG (window)->action_area), 
                      button, TRUE, TRUE, 0);
  gtk_widget_show(button);
  
  
  gtk_widget_show(window);
}


static void about_cb (GtkWidget* widget, gpointer data)
{
    static GtkWidget* dialog = NULL;
    GtkWidget* app;
    gchar* logo;

    app = (GtkWidget*) data;

    if (dialog != NULL)
      {
        g_assert(GTK_WIDGET_REALIZED(dialog));
        gdk_window_show(dialog->window);
        gdk_window_raise(dialog->window);
      }
    else
      {
        const gchar* authors[] = {
          "Benedikt Roth <BenediktRoth@users.sourceforge.net>",
          NULL
        };
        logo = gnome_pixmap_file("change_this_logo.png"); 

        dialog = gnome_about_new (_("Yet Another Mp3 Tool"), VERSION,
                                  "(C) 2000 Benedikt Roth",
                                  authors,
_("A program to organize your mp3s.\n
Visit http://yamt.sourceforge.net"),
                                  logo);

        g_free(logo);

        gtk_signal_connect(GTK_OBJECT(dialog),
                           "destroy",
                           GTK_SIGNAL_FUNC(gtk_widget_destroyed),
                           &dialog);

        gnome_dialog_set_parent(GNOME_DIALOG(dialog), GTK_WINDOW(app));

        gtk_widget_show(dialog);
      }
}
