/* 	$Id: misc.c,v 1.6 2000/01/08 20:02:04 ben Exp $	 */

#include  <stdio.h>
#include  <unistd.h>
#include  <sys/stat.h>
#include  <sys/types.h>
#include  <fcntl.h>

#include  "yamt.h"


void what( GtkWidget *Widget, gpointer *data )
{
  g_print("%s\n", data);
}


void destroy( GtkWidget *widget, gpointer *data )
{
  gtk_widget_destroy( GTK_WIDGET (data) );
}


void yamt_exit( void )
{
  g_print("Normal exit!\n");
  gtk_main_quit();
}


void expand_variables_in_string(gchar *s, guint size, gchar *dir, gchar *fname)
{
  if(!strncmp(s,"%dir",size))
    strncpy(s,dir,size);
  else if(!strncmp(s,"%file",size))
    strncpy(s,fname,size);
}


struct id3tag expand_variables(struct id3tag tag, gchar *dir, gchar *fname)
{
  gchar *index;

  /* find the base part of the name, without the extension */
  fname = strdup(g_basename(fname));
  index = strrchr(fname,'.');
  index=0; 
  
  /* find the base part of the directory */
  dir = g_basename(dir);
  
  expand_variables_in_string(tag.title,31,dir,fname);
  expand_variables_in_string(tag.artist,31,dir,fname);
  expand_variables_in_string(tag.album,31,dir,fname);
  expand_variables_in_string(tag.comment,31,dir,fname);
  expand_variables_in_string(tag.year,4,dir,fname);
  
  free(fname); /*  fname has been strduped */
 
  return tag;
}


int play_file( gchar *file )
{
  pid_t pid;
  gchar buffer[80];
  gchar command[80];

  strcpy( buffer, "\"" );
  strcat( buffer, file );
  strcat( buffer, "\"" );
  
  strcpy( command, prop_mp3_player);
  strcat( command, " ");

  strcat( command, buffer);
  g_print("command: %s\n", command);

  pid = fork();
  switch (pid)
    {
    case -1:
      printf("Fork failed!\n");
      break;
    case 0:
      system(command);
      _exit(1);
      break;
    default:
      break;
    }
  return(0);
}


int get_header_data( char *filename, struct mpegformat_t *header )
{
  char         header_buffer[MPEG_HEADER_LENGTH];
  struct stat  stbuf;
  int          mp3_fd;
  int          filesize;

  /* check if file exists and get the file size */
  if (stat(filename, &stbuf) == -1)
    {
      printf("ERROR File not found: %s \n", filename);
      exit(-1);
    }
  filesize = (long)stbuf.st_size;
  
  mp3_fd = open(filename, O_RDONLY);
  
  /* Read the header into the buffer */
  read(mp3_fd, &header_buffer, MPEG_HEADER_LENGTH); 

  close(mp3_fd);

  /* Process header */
  mpegGetFormat(&header_buffer, header);

  /* if it seems to be a valid file output its format */
  if (header->version != -1)
    {
      /* calculate duration of the MP3-song */
      header->totalframes=(long)((double)filesize/header->framesize);
      header->duration=header->totalframes*((float)1152/(float)header->version)/(float)header->samplerate;
      return(1);
    }
  else
    return(0);
}
