/* 	$Id: page_edit.c,v 1.2 2000/01/08 19:57:28 ben Exp $	 */

#include <gnome.h>

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <stdlib.h>

#include  "yamt.h"
#include  "page_edit.h"


GtkWidget *edit_box_new( )
{
  GtkWidget *box;
  
  /* File info */
  GtkWidget *edit_file_info_frame;
  GtkWidget *edit_file_info_table;
  GtkWidget *edit_file_info_label_filename;
  GtkWidget *edit_file_info_buttons_select;

  /* Tag info */
  GtkWidget *edit_tag_frame;
  GtkWidget *edit_tag_table;
  
  GtkWidget *edit_tag_label_title;
  GtkWidget *edit_tag_label_artist;
  GtkWidget *edit_tag_label_album;
  GtkWidget *edit_tag_label_comment;
  GtkWidget *edit_tag_label_year;
  GtkWidget *edit_tag_label_genre;

  /* Buttons */ 
  GtkWidget *edit_buttons_box;
  GtkWidget *edit_buttons_quit;
  GtkWidget *edit_buttons_play;
  GtkWidget *edit_buttons_save;

  gint i;

/* The box it which everything is put */
  box = gtk_vbox_new( FALSE, 0);
    
  /******************************************* FILE INFO *******************************************/
  /* Frame for file info */
  edit_file_info_frame = gtk_frame_new( NULL );
  gtk_frame_set_label( GTK_FRAME (edit_file_info_frame), _("File Information") );
  gtk_box_pack_start( GTK_BOX (box), edit_file_info_frame, TRUE, FALSE, 0 );
  gtk_widget_show( edit_file_info_frame );

  /* Table for file info */
  edit_file_info_table = gtk_table_new( 3, 3, FALSE);
  gtk_container_set_border_width( GTK_CONTAINER (edit_file_info_table), 2);
  gtk_table_set_row_spacings( GTK_TABLE (edit_file_info_table), 5 );
  gtk_table_set_col_spacings( GTK_TABLE (edit_file_info_table), 10 );
  gtk_container_add( GTK_CONTAINER (edit_file_info_frame), edit_file_info_table); 
  gtk_widget_show(edit_file_info_table);

  /* File */
  edit_file_info_label_filename=gtk_label_new( _("File: ") );
  gtk_table_attach_defaults( GTK_TABLE (edit_file_info_table), edit_file_info_label_filename, 0, 1, 0, 1);
  gtk_widget_show( edit_file_info_label_filename );

  edit_file_info_filename=gtk_label_new( _("[no file selected]") );
  gtk_table_attach_defaults( GTK_TABLE (edit_file_info_table), edit_file_info_filename, 1, 2, 0, 1);
  gtk_widget_show( edit_file_info_filename );

  /* The select button */
  edit_file_info_buttons_select = gnome_stock_or_ordinary_button( GNOME_STOCK_PIXMAP_OPEN );
  gtk_signal_connect( GTK_OBJECT (edit_file_info_buttons_select), "clicked", 
		      GTK_SIGNAL_FUNC (edit_file_select), NULL); 
  gtk_table_attach_defaults( GTK_TABLE (edit_file_info_table), edit_file_info_buttons_select, 2, 3, 0, 1);
  gtk_widget_show( edit_file_info_buttons_select );

  /* Mpeg version */
  edit_file_info_mpeg=gtk_label_new( _("MPEG Version") );
  gtk_table_attach_defaults( GTK_TABLE (edit_file_info_table), edit_file_info_mpeg, 0, 1, 1, 2);
  gtk_widget_show( edit_file_info_mpeg );

  /* Layer version */
  edit_file_info_layer=gtk_label_new( _("Layer Version") );
  gtk_table_attach_defaults( GTK_TABLE (edit_file_info_table), edit_file_info_layer, 1, 2, 1, 2);
  gtk_widget_show( edit_file_info_layer );

  /* Mode */
  edit_file_info_mode=gtk_label_new( _("Mode") );
  gtk_table_attach_defaults( GTK_TABLE (edit_file_info_table), edit_file_info_mode, 2, 3, 1, 2);
  gtk_widget_show( edit_file_info_mode );

  /* Samplerate */
  edit_file_info_samplerate=gtk_label_new( _("Sampelrate") );
  gtk_table_attach_defaults( GTK_TABLE (edit_file_info_table), edit_file_info_samplerate, 0, 1, 2, 3);
  gtk_widget_show( edit_file_info_samplerate );

  /* Kilobitrate */
  edit_file_info_kilobitrate=gtk_label_new( _("Kilobitrate") );
  gtk_table_attach_defaults( GTK_TABLE (edit_file_info_table), edit_file_info_kilobitrate, 1, 2, 2, 3);
  gtk_widget_show( edit_file_info_kilobitrate );

  /* Duration */
  edit_file_info_duration=gtk_label_new( _("Duration") );
  gtk_table_attach_defaults( GTK_TABLE (edit_file_info_table), edit_file_info_duration, 2, 3, 2, 3);
  gtk_widget_show( edit_file_info_duration );

  /*******************************************  ID3  TAG  *******************************************/
  /* Frame for the id3 tag */
  edit_tag_frame = gtk_frame_new( NULL );
  gtk_frame_set_label( GTK_FRAME (edit_tag_frame), _("ID3 TAG") );
  gtk_box_pack_start( GTK_BOX (box), edit_tag_frame, TRUE, FALSE, 5 );
  gtk_widget_show( edit_tag_frame );

  /* Table for id3 tag */
  edit_tag_table = gtk_table_new( 5, 4, FALSE);
  gtk_container_add( GTK_CONTAINER (edit_tag_frame), edit_tag_table);
  gtk_widget_show(edit_tag_table);

  /* Title */
  edit_tag_label_title=gtk_label_new( _("Title: ") );
  gtk_misc_set_alignment( GTK_MISC (edit_tag_label_title), 1, 0.5 );
  gtk_table_attach_defaults( GTK_TABLE (edit_tag_table), edit_tag_label_title, 0, 1, 0, 1);
  gtk_widget_show( edit_tag_label_title );

  edit_tag_title = gtk_entry_new_with_max_length(30);
  gtk_entry_set_editable( GTK_ENTRY (edit_tag_title), TRUE );
  gtk_table_attach_defaults( GTK_TABLE (edit_tag_table), edit_tag_title, 1, 4, 0, 1);
  gtk_widget_show( edit_tag_title );

  /* Artist */
  edit_tag_label_artist=gtk_label_new( _("Artist: ") );
  gtk_misc_set_alignment( GTK_MISC (edit_tag_label_artist), 1, 0.5 );
  gtk_table_attach_defaults( GTK_TABLE (edit_tag_table), edit_tag_label_artist, 0, 1, 1, 2);
  gtk_widget_show( edit_tag_label_artist );

  edit_tag_artist = gtk_entry_new_with_max_length(30);
  gtk_table_attach_defaults( GTK_TABLE (edit_tag_table), edit_tag_artist, 1, 4, 1, 2);
  gtk_widget_show( edit_tag_artist );

  /* Album */
  edit_tag_label_album=gtk_label_new( _("Album: ") );
  gtk_misc_set_alignment( GTK_MISC (edit_tag_label_album), 1, 0.5 );
  gtk_table_attach_defaults( GTK_TABLE (edit_tag_table), edit_tag_label_album, 0, 1, 2, 3);
  gtk_widget_show( edit_tag_label_album );

  edit_tag_album = gtk_entry_new_with_max_length(30);
  gtk_table_attach_defaults( GTK_TABLE (edit_tag_table), edit_tag_album, 1, 4, 2, 3);
  gtk_widget_show( edit_tag_album );

  /* Comment */
  edit_tag_label_comment=gtk_label_new( _("Comment: ") );
  gtk_misc_set_alignment( GTK_MISC (edit_tag_label_comment), 1, 0.5 );
  gtk_table_attach_defaults( GTK_TABLE (edit_tag_table), edit_tag_label_comment, 0, 1, 3, 4);
  gtk_widget_show( edit_tag_label_comment );

  edit_tag_comment = gtk_entry_new_with_max_length(30);
  gtk_table_attach_defaults( GTK_TABLE (edit_tag_table), edit_tag_comment, 1, 4, 3, 4);
  gtk_widget_show( edit_tag_comment );

  /* Year */
  edit_tag_label_year=gtk_label_new( _("Year: ") );
  gtk_misc_set_alignment( GTK_MISC (edit_tag_label_year), 1, 0.5 );
  gtk_table_attach_defaults( GTK_TABLE (edit_tag_table), edit_tag_label_year, 0, 1, 4, 5);
  gtk_widget_show( edit_tag_label_year );

  edit_tag_year = gtk_entry_new_with_max_length(4);
  gtk_table_attach_defaults( GTK_TABLE (edit_tag_table), edit_tag_year, 1, 2, 4, 5);
  gtk_widget_show( edit_tag_year );

  /* Genre */
  edit_tag_label_genre=gtk_label_new( _("Genre: ") );
  gtk_misc_set_alignment( GTK_MISC (edit_tag_label_genre), 1, 0.5 );
  gtk_table_attach_defaults( GTK_TABLE (edit_tag_table), edit_tag_label_genre, 2, 3, 4, 5);
  gtk_widget_show( edit_tag_label_genre );

  /* Create a new combo box */
  edit_tag_genre = gtk_combo_new();
  gtk_entry_set_editable( GTK_ENTRY (GTK_COMBO(edit_tag_genre)->entry), FALSE);
  /* Create the CList */
  if (!edit_tag_genre_list)
    {
      for (i = 0; i < GENRE_MAX; i++)
	edit_tag_genre_list = g_list_append( edit_tag_genre_list, (gchar *) id3tag_genre_names[i]);
      edit_tag_genre_list = g_list_append(edit_tag_genre_list, "");
    }
  /* Connect the combo and the list */
  gtk_combo_set_popdown_strings(GTK_COMBO(edit_tag_genre), edit_tag_genre_list);
  gtk_table_attach_defaults( GTK_TABLE (edit_tag_table), edit_tag_genre, 3, 4, 4, 5);
  gtk_entry_set_text( GTK_ENTRY(GTK_COMBO (edit_tag_genre)->entry), " ");
  gtk_widget_show(edit_tag_genre);

  /*******************************************  BUTTONS   *******************************************/
  /* The Box for the buttons */
  edit_buttons_box = gtk_hbox_new( TRUE, 60 );
  gtk_box_pack_start( GTK_BOX (box), edit_buttons_box, TRUE, FALSE, 0 );
  gtk_widget_show( edit_buttons_box );

  /* The buttons */
  edit_buttons_save = gnome_stock_or_ordinary_button( GNOME_STOCK_PIXMAP_SAVE );
  gtk_signal_connect( GTK_OBJECT (edit_buttons_save), "clicked", 
		      GTK_SIGNAL_FUNC (edit_file_save), NULL ); 
  gtk_box_pack_start( GTK_BOX (edit_buttons_box), edit_buttons_save, TRUE, TRUE, 0 );
  gtk_widget_show( edit_buttons_save );

  edit_buttons_play = gnome_stock_or_ordinary_button( _("Play") );
  gtk_signal_connect( GTK_OBJECT (edit_buttons_play), "clicked", 
		      GTK_SIGNAL_FUNC (edit_file_play), NULL ); 
  gtk_box_pack_start( GTK_BOX (edit_buttons_box), edit_buttons_play, TRUE, TRUE, 0 );
  gtk_widget_show( edit_buttons_play );

  edit_buttons_quit = gnome_stock_or_ordinary_button( GNOME_STOCK_PIXMAP_QUIT );
  gtk_signal_connect( GTK_OBJECT (edit_buttons_quit), "clicked",
                      GTK_SIGNAL_FUNC (gtk_exit), NULL );
  gtk_box_pack_start( GTK_BOX (edit_buttons_box), edit_buttons_quit, TRUE, TRUE, 0 );
  gtk_widget_show( edit_buttons_quit );

  return(box);
}


void edit_file_select( void )
{
  GtkWidget *filew;

  filew = gtk_file_selection_new( _("Select MP3 FILE") );

  gtk_signal_connect( GTK_OBJECT (filew), "destroy",
		      GTK_SIGNAL_FUNC (gtk_widget_destroy), filew);
  
  /* Connect the ok buton to load_file */
  gtk_signal_connect( GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), "clicked", 
 		      GTK_SIGNAL_FUNC (edit_lf), filew); 
  gtk_signal_connect( GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), "clicked",
		      GTK_SIGNAL_FUNC (destroy), filew);
  
  /* Connect the cancel  buton to destroy */  
  gtk_signal_connect( GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button), "clicked",
		      GTK_SIGNAL_FUNC (destroy), filew);
  
  gtk_widget_show(filew);
}


int edit_tag_new( gint reply, gpointer *data )
{
  char filename[BUFFERSIZE];

  strcpy( filename, mfile.path );
  strcat( filename, mfile.filename );
  
  g_print("filename: %s\n", filename);
  
  if( reply == 0 )   /* Yes was selected */
    {
      g_print("yes!\n");
      id3tag_new( filename );
      edit_file_load( filename );
    }
  else
    {
      g_print("no!\n");
      mfile.path[0]='\0';
      mfile.filename[0]='\0';
    }
  return(1);
}


void edit_file_play( void )
{
  gchar *dirandfile;

  dirandfile = g_concat_dir_and_file( mfile.path, mfile.filename );
  
  play_file( dirandfile );

  g_free( dirandfile );
}

int edit_file_load( gchar *filename )
{
  gchar buffer[80];
  gint i;
  gint i2;

  /* Seperate path and filename */
  /* ONLY BETA, WON'T WORK WITH SLASHES IN FILENAMES !!! */
  for( i=strlen(filename); i>0; i-- )
      if( filename[i] == '/' )
	break;

  for( i2=0; i2 != i+1; i2++ )
    buffer[i2] = filename[i2];
  
  buffer[i2] = '\0';
  strcpy( mfile.path, buffer );
  g_print("mfile.path: %s\n", mfile.path);
  
  for( i2=0, i=i+1; i<strlen(filename); i++, i2++ )
      buffer[i2]=filename[i];

  buffer[i2] = '\0';
  strcpy( mfile.filename, buffer );
  g_print("mfile.filename: %s\n", mfile.filename);

  
  g_print("Loading file %s...\n", filename);
  mfile.tag = id3tag_get( filename );
  /* If the file has no valid tag */
  if( strncmp( mfile.tag.tag, "TAG", 3 ) != 0 )
    {
      printf("Skipped \"%s\". No valid tag!\n",filename);
      gnome_app_question_modal( GNOME_APP (app),
				_("File has no ID3 TAG. Do you want to write it?"),
				edit_tag_new, NULL );
      return(0);
    }

  id3tag_show( mfile.tag );
  get_header_data( filename, &mfile.header );
  mfile.mins=mfile.header.duration/60;
  mfile.secs=mfile.header.duration % 60;
  
  /******************************************* FILE INFO *******************************************/

  /* Filename */
  gtk_label_set_text( GTK_LABEL (edit_file_info_filename), mfile.filename );
  gtk_widget_show(edit_file_info_filename);

  /* Mpeg Version */
  sprintf( buffer, _("MPEG %i"), mfile.header.version);
  gtk_label_set_text( GTK_LABEL (edit_file_info_mpeg), buffer );
  gtk_widget_show(edit_file_info_mpeg);

  /* Layer Version */
  sprintf( buffer, "Layer%i", mfile.header.layer);
  gtk_label_set_text( GTK_LABEL (edit_file_info_layer), buffer );
  gtk_widget_show(edit_file_info_layer);
  
  /* Mode */
  strcpy( buffer, "Mode: ");
  switch(mfile.header.channels)
    {
	case SINGLE_CHANNEL: strcat( buffer, _("Single Channel") ); break;
	case DUAL_CHANNEL  : strcat( buffer, _("Dual Channel") ); break;
	case JOINT_STEREO  : strcat( buffer, _("Joint Stereo") ); break;
	case STEREO        : strcat( buffer, _("Stereo") ); break;
	default		   : strcat( buffer, _("Unknown") ); break;
    }
  gtk_label_set_text( GTK_LABEL (edit_file_info_mode), buffer );
  gtk_widget_show(edit_file_info_mode);

  /* Samplerate */
  sprintf( buffer, _("%i Hz"), mfile.header.samplerate );
  gtk_label_set_text( GTK_LABEL (edit_file_info_samplerate), buffer );
  gtk_widget_show(edit_file_info_samplerate);

  /* Kilobitrate */
  sprintf( buffer, _("%i Kbit/s"), mfile.header.kilobitrate );
  gtk_label_set_text( GTK_LABEL (edit_file_info_kilobitrate), buffer );
  gtk_widget_show(edit_file_info_kilobitrate);

  /* Duration */
  sprintf( buffer, _("%i:%im (%i s)"), mfile.mins, mfile.secs, mfile.header.duration);
  gtk_label_set_text( GTK_LABEL (edit_file_info_duration), buffer );
  gtk_widget_show( edit_file_info_duration );


  /*******************************************  ID3  TAG  *******************************************/

  /* Title */
  gtk_entry_set_text( GTK_ENTRY (edit_tag_title), mfile.tag.title);
  gtk_widget_show( edit_tag_title );
 
  /* Artist */
  gtk_entry_set_text( GTK_ENTRY (edit_tag_artist), mfile.tag.artist);
  gtk_widget_show( edit_tag_artist );

  /* Album */
  gtk_entry_set_text( GTK_ENTRY (edit_tag_album), mfile.tag.album);
  gtk_widget_show( edit_tag_album );

  /* Comment */
  gtk_entry_set_text( GTK_ENTRY (edit_tag_comment), mfile.tag.comment);
  gtk_widget_show( edit_tag_comment );

  /* Year */
  gtk_entry_set_text( GTK_ENTRY (edit_tag_year), mfile.tag.year);
  gtk_widget_show( edit_tag_year );

  /* Genre */
  sprintf( buffer, id3tag_genre_names[mfile.tag.genre] );
  gtk_entry_set_text( GTK_ENTRY(GTK_COMBO (edit_tag_genre)->entry), buffer );
  gtk_widget_show(edit_tag_genre); 

  
  /*******************************************   E N D   *******************************************/
  g_print("...ok!\n");
  return(1);
}

/* I don't know how to pass the filename directly to load_file so I use this function */
void edit_lf( GtkWidget *widget, GtkFileSelection *file_selection )
{
  gchar *filename=gtk_file_selection_get_filename( GTK_FILE_SELECTION (file_selection));

  edit_file_load( filename );
}


int edit_file_save( void )
{
  gchar filename[120];
  gchar *buffer;
  gchar *buffer2;
  gint i;
  
  strcpy( filename, mfile.path );
  strcat( filename, mfile.filename );

  if( filename[0] == '\0' )
    {
      g_print("Nothing done!\n");
      return(0);
    }
  g_print("Saving file %s...", filename);

  /* Title */
  buffer = gtk_entry_get_text( GTK_ENTRY (edit_tag_title) );
  /* To get sure the tag will be deleted */ 
  if( buffer[0] == '\0' )
    {
      buffer[0]=' '; buffer[1]='\0';
    }
  
  strcpy( mfile.tag.title, buffer );
  
  /* Artist */
  buffer = gtk_entry_get_text( GTK_ENTRY (edit_tag_artist) );
    if( buffer[0] == '\0' )
    {
      buffer[0]=' '; buffer[1]='\0';
    }
  strcpy( mfile.tag.artist, buffer );

  /* Album */
  buffer = gtk_entry_get_text( GTK_ENTRY (edit_tag_album) );
    if( buffer[0] == '\0' )
    {
      buffer[0]=' '; buffer[1]='\0';
    }
  strcpy( mfile.tag.album, buffer );

  /* Comment */
  buffer = gtk_entry_get_text( GTK_ENTRY (edit_tag_comment) );
  if( buffer[0] == '\0' )
    {
      buffer[0]=' '; buffer[1]='\0';
    }
  strcpy( mfile.tag.comment, buffer );

  /* Year */
  buffer = gtk_entry_get_text( GTK_ENTRY (edit_tag_year) );
  if( buffer[0] == '\0' )
    {
      buffer[0]=' '; buffer[1]='\0';
    }
  strcpy( mfile.tag.year, buffer );
  
  /* Genre */
  buffer = gtk_entry_get_text( GTK_ENTRY (GTK_COMBO(edit_tag_genre)->entry) );

  /*   g_print("\ngenre: %i | %c\n", buffer[0], buffer[0] ); */

  mfile.tag.genre=EOF; 
  for( i=0; i<GENRE_MAX; i++) 
    { 
      buffer2 = id3tag_genre_names[i];
/*       g_print("%i\n", i); */
/*       g_print("buffer: %s\n", buffer); */
/*       g_print("buffer2: %s\n", buffer2); */
      if( (strcmp( buffer, buffer2))==0) 
	{ 
 	  mfile.tag.genre=i; 
  	  break;  
  	}  
     } 
  
   if( mfile.tag.genre == EOF ) 
     g_print("Genre set to unknown!\n");
   
/*   g_print("\ngenre: %i | %c\n", mfile.tag.genre, mfile.tag.genre ); */
   
  id3tag_show( mfile.tag );
  
  id3tag_set( filename, mfile.tag );
  g_print("...ok\n");
  return(1);
}
