/* 	$Id: page_find.c,v 1.4 2000/01/08 20:00:02 ben Exp $	 */

#include <gnome.h>

#include <stdio.h>
#include <unistd.h>
#include <dirent.h>
#include <string.h>
#include <sys/stat.h>
#include <stdlib.h>

#include "yamt.h"
#include "page_find.h"


gchar *find_results_results[100][2];


GtkWidget *find_box_new( )
{
  GtkWidget *box;
  
  GtkWidget *find_frame_directory;
  GtkWidget *find_table_directory;
  
  GtkWidget *find_label_directory;

  GtkWidget *find_tag_label_title;
  GtkWidget *find_tag_label_artist;
  GtkWidget *find_tag_label_album;
  GtkWidget *find_tag_label_comment;
  GtkWidget *find_tag_label_year;
  GtkWidget *find_tag_label_genre;

  GtkWidget *find_tag_frame;
  GtkWidget *find_tag_table;
  
  GtkWidget *find_button_select;
  GtkWidget *find_buttons_box;
  GtkWidget *find_buttons_quit;
  GtkWidget *find_buttons_start;

  gint i;
  
  
  /* The box it which everything is put */
  box = gtk_vbox_new( FALSE, 0);
  
  /* Frame for directory */
  find_frame_directory = gtk_frame_new( NULL );
  gtk_box_pack_start( GTK_BOX (box), find_frame_directory, TRUE, FALSE, 0 );
  gtk_widget_show( find_frame_directory );

  /* Table for directory */
  find_table_directory = gtk_table_new( 1, 1, TRUE);
  gtk_container_set_border_width( GTK_CONTAINER (find_table_directory), 5);
  gtk_container_add( GTK_CONTAINER (find_frame_directory), find_table_directory ); 
  gtk_widget_show( find_table_directory );
    
  /* Directory */
  find_label_directory=gtk_label_new( _("Directory: ") );
  gtk_table_attach_defaults( GTK_TABLE (find_table_directory), find_label_directory, 0, 1, 0, 1);
  gtk_widget_show( find_label_directory );

  find_directory=gtk_label_new( prop_mp3_dir );
  gtk_table_attach_defaults( GTK_TABLE (find_table_directory), find_directory, 1, 2, 0, 1); 
  gtk_widget_show( find_directory );
  
  /* The select button */
  find_button_select = gnome_stock_or_ordinary_button( GNOME_STOCK_PIXMAP_OPEN );
  gtk_signal_connect( GTK_OBJECT (find_button_select), "clicked", 
		      GTK_SIGNAL_FUNC (find_directory_select), "Select Directory"); 
  gtk_table_attach_defaults( GTK_TABLE (find_table_directory), find_button_select, 2, 3, 0, 1); 
  gtk_widget_show( find_button_select );

  /* The recursive button */
  find_buttons_recursive = gtk_check_button_new_with_label( _("Recurse Subdirs") );
  gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON (find_buttons_recursive), FALSE ); 
  gtk_table_attach_defaults( GTK_TABLE (find_table_directory), find_buttons_recursive, 1, 2, 1, 2);
  gtk_widget_show( find_buttons_recursive );

  /*******************************************  ID3  TAG  *******************************************/
  /* Frame for the id3 tag */
  find_tag_frame = gtk_frame_new( NULL );
  gtk_frame_set_label( GTK_FRAME (find_tag_frame), _("ID3 TAG") );
  gtk_box_pack_start( GTK_BOX (box), find_tag_frame, TRUE, FALSE, 0 );
  gtk_widget_show( find_tag_frame );

  /* Table for id3 tag */
  find_tag_table = gtk_table_new( 6, 4, FALSE);
  gtk_container_add( GTK_CONTAINER (find_tag_frame), find_tag_table);
  gtk_widget_show(find_tag_table);

  /* Title */
  find_tag_label_title=gtk_label_new( _("Title: ") );
  gtk_misc_set_alignment( GTK_MISC (find_tag_label_title), 1, 0.5 );
  gtk_table_attach_defaults( GTK_TABLE (find_tag_table), find_tag_label_title, 0, 1, 0, 1);
  gtk_widget_show( find_tag_label_title );

  find_tag_title = gtk_entry_new_with_max_length(30);
  gtk_entry_set_editable( GTK_ENTRY (find_tag_title), FALSE );
  gtk_table_attach_defaults( GTK_TABLE (find_tag_table), find_tag_title, 1, 3, 0, 1);
  gtk_widget_show( find_tag_title );

  find_buttons_title = gtk_check_button_new_with_label( _("Use this field") );
  gtk_signal_connect( GTK_OBJECT (find_buttons_title), "clicked",
		      GTK_SIGNAL_FUNC (find_use_field_button_toggled), "t" );
  gtk_table_attach_defaults( GTK_TABLE (find_tag_table), find_buttons_title, 3, 4, 0, 1);
  gtk_widget_show( find_buttons_title );

  /* Artist */
  find_tag_label_artist=gtk_label_new( _("Artist: "));
  gtk_misc_set_alignment( GTK_MISC (find_tag_label_artist), 1, 0.5 );
  gtk_table_attach_defaults( GTK_TABLE (find_tag_table), find_tag_label_artist, 0, 1, 1, 2);
  gtk_widget_show( find_tag_label_artist );

  find_tag_artist = gtk_entry_new_with_max_length(30);
  gtk_entry_set_editable( GTK_ENTRY (find_tag_artist), FALSE );
  gtk_table_attach_defaults( GTK_TABLE (find_tag_table), find_tag_artist, 1, 3, 1, 2);
  gtk_widget_show( find_tag_artist );

  find_buttons_artist = gtk_check_button_new_with_label( _("Use this field") );
  gtk_signal_connect( GTK_OBJECT (find_buttons_artist), "clicked",
		      GTK_SIGNAL_FUNC (find_use_field_button_toggled), "a" );
  gtk_table_attach_defaults( GTK_TABLE (find_tag_table), find_buttons_artist, 3, 4, 1, 2);
  gtk_widget_show( find_buttons_artist );

  
  /* Album */
  find_tag_label_album=gtk_label_new( _("Album: ") );
  gtk_misc_set_alignment( GTK_MISC (find_tag_label_album), 1, 0.5 );
  gtk_table_attach_defaults( GTK_TABLE (find_tag_table), find_tag_label_album, 0, 1, 2, 3);
  gtk_widget_show( find_tag_label_album );

  find_tag_album = gtk_entry_new_with_max_length(30);
  gtk_entry_set_editable( GTK_ENTRY (find_tag_album), FALSE );
  gtk_table_attach_defaults( GTK_TABLE (find_tag_table), find_tag_album, 1, 3, 2, 3);
  gtk_widget_show( find_tag_album );

  find_buttons_album = gtk_check_button_new_with_label( _("Use this field") );
  gtk_signal_connect( GTK_OBJECT (find_buttons_album), "clicked",
		      GTK_SIGNAL_FUNC (find_use_field_button_toggled), "b" );
  gtk_table_attach_defaults( GTK_TABLE (find_tag_table), find_buttons_album, 3, 4, 2, 3);
  gtk_widget_show( find_buttons_album );

  /* Comment */
  find_tag_label_comment=gtk_label_new( _("Comment: ") );
  gtk_misc_set_alignment( GTK_MISC (find_tag_label_comment), 1, 0.5 );
  gtk_table_attach_defaults( GTK_TABLE (find_tag_table), find_tag_label_comment, 0, 1, 3, 4);
  gtk_widget_show( find_tag_label_comment );

  find_tag_comment = gtk_entry_new_with_max_length(30);
  gtk_entry_set_editable( GTK_ENTRY (find_tag_comment), FALSE );
  gtk_table_attach_defaults( GTK_TABLE (find_tag_table), find_tag_comment, 1, 3, 3, 4);
  gtk_widget_show( find_tag_comment );

  find_buttons_comment = gtk_check_button_new_with_label( _("Use this field") );
  gtk_signal_connect( GTK_OBJECT (find_buttons_comment), "clicked",
		      GTK_SIGNAL_FUNC (find_use_field_button_toggled), "c" );
  gtk_table_attach_defaults( GTK_TABLE (find_tag_table), find_buttons_comment, 3, 4, 3, 4);
  gtk_widget_show( find_buttons_comment );

  /* Year */
  find_tag_label_year=gtk_label_new( _("Year: ") );
  gtk_misc_set_alignment( GTK_MISC (find_tag_label_year), 1, 0.5 );
  gtk_table_attach_defaults( GTK_TABLE (find_tag_table), find_tag_label_year, 0, 1, 4, 5);
  gtk_widget_show( find_tag_label_year );

  find_tag_year = gtk_entry_new_with_max_length(4);
  gtk_entry_set_editable( GTK_ENTRY (find_tag_year), FALSE );
  gtk_table_attach_defaults( GTK_TABLE (find_tag_table), find_tag_year, 1, 3, 4, 5);
  gtk_widget_show( find_tag_year );

  find_buttons_year = gtk_check_button_new_with_label( _("Use this field") );
  gtk_signal_connect( GTK_OBJECT (find_buttons_year), "clicked",
		      GTK_SIGNAL_FUNC (find_use_field_button_toggled), "y" );
  gtk_table_attach_defaults( GTK_TABLE (find_tag_table), find_buttons_year, 3, 4, 4, 5); 
  gtk_widget_show( find_buttons_year ); 
  
  /* Genre */
  find_tag_label_genre=gtk_label_new( _("Genre: ") );
  gtk_misc_set_alignment( GTK_MISC (find_tag_label_genre), 1, 0.5 );
  gtk_table_attach_defaults( GTK_TABLE (find_tag_table), find_tag_label_genre, 0, 1, 5, 6);
  gtk_widget_show( find_tag_label_genre );


  /* !!!!!!!!!!!!!!!!!!!!!!!!!!!! */
  
  /* Create a new combo box */
  find_tag_genre = gtk_combo_new();
  gtk_entry_set_editable( GTK_ENTRY (GTK_COMBO(find_tag_genre)->entry), FALSE);
  /* Create the CList */
  if (!find_tag_genre_list)
    {
      for (i = 0; i < GENRE_MAX; i++)
	find_tag_genre_list = g_list_append( find_tag_genre_list, (gchar *) id3tag_genre_names[i]);
      find_tag_genre_list = g_list_append(find_tag_genre_list, "");
    }
  /* Connect the combo and the list */
  gtk_combo_set_popdown_strings(GTK_COMBO(find_tag_genre), find_tag_genre_list);
  gtk_table_attach_defaults( GTK_TABLE (find_tag_table), find_tag_genre, 1, 2, 5, 6);
  gtk_entry_set_text( GTK_ENTRY(GTK_COMBO (find_tag_genre)->entry), " ");
  gtk_widget_show(find_tag_genre);

  find_buttons_genre = gtk_check_button_new_with_label( _("Use this field") );
  gtk_signal_connect( GTK_OBJECT (find_buttons_genre), "clicked",
		      GTK_SIGNAL_FUNC (find_use_field_button_toggled), "g" );
  gtk_table_attach_defaults( GTK_TABLE (find_tag_table), find_buttons_genre, 3, 4, 5, 6); 
  gtk_widget_show( find_buttons_genre ); 

  
  /* The Box for the buttons */
  find_buttons_box = gtk_hbox_new( TRUE, 10);
  gtk_container_set_border_width( GTK_CONTAINER (find_buttons_box), 5);
  gtk_box_pack_start( GTK_BOX (box), find_buttons_box, TRUE, FALSE, 0 );
  gtk_widget_show( find_buttons_box );
  
  /* The Buttons */
  find_buttons_start = gnome_stock_or_ordinary_button( GNOME_STOCK_PIXMAP_SEARCH );
  gtk_signal_connect( GTK_OBJECT (find_buttons_start), "clicked", 
		      GTK_SIGNAL_FUNC (find_start), NULL ); 
  gtk_box_pack_start( GTK_BOX (find_buttons_box), find_buttons_start, TRUE, TRUE, 0 );
  gtk_widget_show( find_buttons_start );

  find_buttons_quit = gnome_stock_or_ordinary_button( GNOME_STOCK_PIXMAP_QUIT );
  gtk_signal_connect( GTK_OBJECT (find_buttons_quit), "clicked",
                      GTK_SIGNAL_FUNC (gtk_exit), NULL );
  gtk_box_pack_start( GTK_BOX (find_buttons_box), find_buttons_quit, TRUE, TRUE, 0 );
  gtk_widget_show( find_buttons_quit );

  return(box);
}


void find_use_field_button_toggled( GtkWidget *widget, gchar *data )
{
  gboolean state;
  
  switch( data[0] )
    {
    case 't':
      /* Get the current state of the button */
      state = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON (find_buttons_title) );
      /* If the button is active make the entry editable, if not then not */
      if( state == TRUE )
	gtk_entry_set_editable( GTK_ENTRY (find_tag_title), TRUE );
      else
	gtk_entry_set_editable( GTK_ENTRY (find_tag_title), FALSE );
      break;

    case 'a':
      state = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON (find_buttons_artist) );
      if( state == TRUE )
	gtk_entry_set_editable( GTK_ENTRY (find_tag_artist), TRUE);
      else
      	gtk_entry_set_editable( GTK_ENTRY (find_tag_artist), FALSE );	
      break;
      
    case 'b':
      state = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON (find_buttons_album) );
      if( state == TRUE )
	gtk_entry_set_editable( GTK_ENTRY (find_tag_album), TRUE );
      else
      	gtk_entry_set_editable( GTK_ENTRY (find_tag_album), FALSE );
      break;

    case 'c':
      state = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON (find_buttons_comment) );
      if( state == TRUE )
	gtk_entry_set_editable( GTK_ENTRY (find_tag_comment), TRUE );
      else
	gtk_entry_set_editable( GTK_ENTRY (find_tag_comment), FALSE );
      break;

    case 'y':
      state = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON (find_buttons_year) );
      if( state == TRUE )	
	gtk_entry_set_editable( GTK_ENTRY (find_tag_year), TRUE );
      else
      	gtk_entry_set_editable( GTK_ENTRY (find_tag_year), FALSE );
      break;

    case 'g':
      state = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON (find_buttons_genre) );
      if( state == TRUE )	
	g_print("Genre TRUE\n");
      else
	g_print("Genre FALSE\n");
      break;
    }
}


void find_directory_select( void )
{
  GtkWidget *filew;

  filew = gtk_file_selection_new( _("Select a Directory") );

  gtk_signal_connect( GTK_OBJECT (filew), "destroy",
		      GTK_SIGNAL_FUNC (gtk_widget_destroy), filew);
  
  /* Connect the ok button to load_file */
  gtk_signal_connect( GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), "clicked", 
 		      GTK_SIGNAL_FUNC (find_lf), filew); 
  gtk_signal_connect( GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), "clicked",
		      GTK_SIGNAL_FUNC (destroy), filew);
  
  /* Connect the cancel  button to destroy */  
  gtk_signal_connect( GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button), "clicked",
		      GTK_SIGNAL_FUNC (destroy), filew);
  
  gtk_widget_show(filew);
}

			      
/* I don't know how to pass the filename directly to load_file so I use this function */
void find_lf( GtkWidget *widget, GtkFileSelection *file_selection )
{
  gchar *filename=gtk_file_selection_get_filename( GTK_FILE_SELECTION (file_selection));

  find_directory_load( filename );
}


void find_directory_load( gchar *dirname )
{
  gtk_label_set_text( GTK_LABEL (find_directory),dirname);
  g_print("dir: %s\n", dirname );
}


void find_results_play( GtkWidget *widget, gpointer *data )
{
  gchar *dir;
  gchar *file;
  gchar *dirandfile;
 
  gtk_clist_get_text(GTK_CLIST(find_results_list), find_row, 0, &dir); 
  gtk_clist_get_text(GTK_CLIST(find_results_list), find_row, 1, &file);

  dirandfile = g_concat_dir_and_file( dir, file );
    
  g_print("dirandfile: %s\n", dirandfile);
  play_file( dirandfile );

  g_free(dirandfile);
  
  return;
}

void find_results_edit( GtkWidget *widget, gpointer *data )
{
  gchar *dir;
  gchar *file;
  gchar *dirandfile;
 
  gtk_clist_get_text(GTK_CLIST(find_results_list), find_row, 0, &dir); 
  gtk_clist_get_text(GTK_CLIST(find_results_list), find_row, 1, &file);

  dirandfile = g_concat_dir_and_file( dir, file );
    
  g_print("dirandfile: %s\n", dirandfile);
  edit_file_load( dirandfile );
  gtk_notebook_set_page( notebook, 0 );   

  g_free(dirandfile);
  
  return;
}


void find_select_filename( void )
{
  GtkWidget *filew;

  filew = gtk_file_selection_new( _("Select a Directory") );
  gtk_file_selection_set_filename( GTK_FILE_SELECTION (filew), "newlist.m3u" );

  gtk_signal_connect( GTK_OBJECT (filew), "destroy",
		      GTK_SIGNAL_FUNC (gtk_widget_destroy), filew);
  
  /* Connect the ok button to load_file */
  gtk_signal_connect( GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), "clicked", 
 		      GTK_SIGNAL_FUNC (find_lf2), filew); 
  gtk_signal_connect( GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), "clicked",
		      GTK_SIGNAL_FUNC (destroy), filew);
  
  /* Connect the cancel  button to destroy */  
  gtk_signal_connect( GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button), "clicked",
		      GTK_SIGNAL_FUNC (destroy), filew);
  
  gtk_widget_show(filew);
}

			      
/* I don't know how to pass the filename directly to load_file so I use this function */
void find_lf2( GtkWidget *widget, GtkFileSelection *file_selection )
{
  gchar *filename=gtk_file_selection_get_filename( GTK_FILE_SELECTION (file_selection));

  find_results_save( filename );
}


void find_results_save( char *filename )
{
  FILE  *filept;
  gchar *dir;
  gchar *file;
  gchar *dirandfile;
  gchar *last;
  gint   i;


  g_print("Filename: %s\n", filename);

  if ( (filept=fopen(filename, "w")) == 0)
    {
      gnome_error_dialog( _("Could not write List!") );
      return;
    }
  
  for( i=0; ;i++)
    {
      g_print("i: %i\n", i);
      gtk_clist_get_text(GTK_CLIST(find_results_list), i, 0, &dir);
      gtk_clist_get_text(GTK_CLIST(find_results_list), i, 1, &file);
      dirandfile = g_concat_dir_and_file( dir, file );
      if( strcmp( dirandfile, last)==0 )
	break;
      g_print("dirandfile: %s\n", dirandfile);
      fputs( dirandfile, filept);
      fputc( '\n', filept);
      last = dirandfile;
    }
  
  g_free(dirandfile);
  fclose(filept);
  gnome_ok_dialog( _("Wrote List!") );
}


void selection_made( GtkWidget      *clist,
		     gint            row,
		     gint            column,
		     GdkEventButton *event,
		     gpointer        data )
{
    gchar *text;
    gchar *dir;
    gchar *file;
    gchar *dirandfile;

    find_row = row;
    find_column = column;
    
    /* Get the text that is stored in the selected row and column
     * which was clicked in. We will receive it as a pointer in the
     * argument text.
     */
    gtk_clist_get_text(GTK_CLIST(clist), row, column, &text);

    /* Just prints some information about the selected row */
    g_print("You selected row %d. More specifically you clicked in "
            "column %d, and the text in this cell is %s\n\n",
	    row, column, text);

    gtk_clist_get_text(GTK_CLIST(clist), row, 0, &dir);
    gtk_clist_get_text(GTK_CLIST(clist), row, 1, &file);

    dirandfile = g_concat_dir_and_file( dir, file );
    
    g_print("dirandfile: %s\n", dirandfile);

    g_free(dirandfile);
    
    return;
}


void find_display_results( void )
{
  GtkWidget *find_results_window;
  GtkWidget *find_results_box;
  GtkWidget *find_results_scrolled_window;
  GtkWidget *find_results_buttons_box;
  GtkWidget *find_results_buttons_save;
  GtkWidget *find_results_buttons_play;
  GtkWidget *find_results_buttons_edit;
  GtkWidget *find_results_buttons_close;
  gchar     *titles[2][2] = { {"Path", "File" }};
  

  find_results_window = gtk_window_new( GTK_WINDOW_TOPLEVEL );
  gtk_window_set_title( GTK_WINDOW (find_results_window), _("YAMT - Search Results") );
 
  find_results_box = gtk_vbox_new( FALSE, 0);
  gtk_container_add( GTK_CONTAINER (find_results_window), find_results_box);
  gtk_widget_show( find_results_box );

  /* Create a scrolled window to pack the CList widget into */
  find_results_scrolled_window = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_set_usize( GTK_WIDGET (find_results_scrolled_window), 400, 300);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (find_results_scrolled_window),
				  GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);

  gtk_box_pack_start(GTK_BOX(find_results_box), find_results_scrolled_window, TRUE, TRUE, 0);
  gtk_widget_show (find_results_scrolled_window);

  /* Create the CList with two columns */
  find_results_list = gtk_clist_new_with_titles( 2, titles );
/*   gtk_clist_set_selection_mode( find_results_list, GTK_SELECTION_MULTIPLE ); */

  /* It isn't necessary to shadow the border, but it looks nice :) */
  gtk_clist_set_shadow_type (GTK_CLIST(find_results_list), GTK_SHADOW_OUT); 
  /* Important !!! */
  gtk_clist_set_column_width (GTK_CLIST(find_results_list), 0, 150);
  gtk_clist_set_column_width (GTK_CLIST(find_results_list), 1, 150);
  /* What do do if the user selects something*/
  gtk_signal_connect(GTK_OBJECT(find_results_list), "select_row",
		     GTK_SIGNAL_FUNC(selection_made), NULL);
  
  gtk_container_add(GTK_CONTAINER(find_results_scrolled_window), find_results_list);
  gtk_widget_show(find_results_list);


  /* The Box for the buttons */
  find_results_buttons_box = gtk_hbox_new( TRUE, 60 );
  gtk_container_set_border_width( GTK_WIDGET (find_results_buttons_box), 5);
  gtk_box_pack_start( GTK_BOX (find_results_box), find_results_buttons_box, TRUE, FALSE, 0 );
  gtk_widget_show( find_results_buttons_box );

  /* The buttons */
  find_results_buttons_save = gnome_stock_or_ordinary_button( GNOME_STOCK_PIXMAP_SAVE );
  gtk_signal_connect( GTK_OBJECT (find_results_buttons_save), "clicked", 
		      GTK_SIGNAL_FUNC (find_select_filename), NULL ); 
  gtk_box_pack_start( GTK_BOX (find_results_buttons_box), find_results_buttons_save, TRUE, TRUE, 0 );
  gtk_widget_show( find_results_buttons_save );

  find_results_buttons_play = gnome_stock_or_ordinary_button( _("Play File") );
  gtk_signal_connect( GTK_OBJECT (find_results_buttons_play), "clicked", 
		      GTK_SIGNAL_FUNC (find_results_play), NULL ); 
  gtk_box_pack_start( GTK_BOX (find_results_buttons_box), find_results_buttons_play, TRUE, TRUE, 0 );
  gtk_widget_show( find_results_buttons_play );

  find_results_buttons_edit = gnome_stock_or_ordinary_button( _("Edit TAG") );
  gtk_signal_connect( GTK_OBJECT (find_results_buttons_edit), "clicked", 
		      GTK_SIGNAL_FUNC (find_results_edit), NULL ); 
  gtk_box_pack_start( GTK_BOX (find_results_buttons_box), find_results_buttons_edit, TRUE, TRUE, 0 );
  gtk_widget_show( find_results_buttons_edit );
  
  find_results_buttons_close = gnome_stock_or_ordinary_button( GNOME_STOCK_PIXMAP_QUIT );
  gtk_signal_connect( GTK_OBJECT (find_results_buttons_close), "clicked",
                      GTK_SIGNAL_FUNC (destroy), find_results_window );
  gtk_box_pack_start( GTK_BOX (find_results_buttons_box), find_results_buttons_close, TRUE, TRUE, 0 );
  gtk_widget_show( find_results_buttons_close );


  gtk_widget_show( find_results_window );
}

int find_start( void )
{
  gchar *directory;
  gchar *buffer;
  gchar *buffer2;
  gboolean active;
  gboolean   recursive;
  struct id3tag tag;
  gint i;
  
  g_print("Find start!\n");

  gtk_label_get( GTK_LABEL (find_directory), &directory );  
  g_print("(Root-)Directory: %s\n", directory);

  recursive = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON (find_buttons_recursive) );
  g_print("recursive: %i\n", recursive );

  strcpy( tag.tag, "TAG" );

  active = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON (find_buttons_title) );
  if( active )
    {
      buffer = gtk_entry_get_text( GTK_ENTRY (find_tag_title) );
      /* To get sure the tag will be deleted */ 
      if( buffer[0] == '\0' )
	{
	  buffer[0]=' '; buffer[1]='\0';
	}
      strcpy( tag.title, buffer );
    }
  else
    tag.title[0]='\0';

  active = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON (find_buttons_artist) );
  if( active )
    {
      buffer = gtk_entry_get_text( GTK_ENTRY (find_tag_artist) );
      if( buffer[0] == '\0' )
	{
	  buffer[0]=' '; buffer[1]='\0';
	}
      strcpy( tag.artist, buffer );
    }
  else
    tag.artist[0]='\0';
  
  active = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON (find_buttons_album) );
  if( active )
    {
      buffer = gtk_entry_get_text( GTK_ENTRY (find_tag_album) );
      if( buffer[0] == '\0' )
	{
	  buffer[0]=' '; buffer[1]='\0';
	}
      strcpy( tag.album, buffer );
    }
  else
    tag.album[0]='\0';
  
  active = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON (find_buttons_comment) );
  if( active )
    {
      buffer = gtk_entry_get_text( GTK_ENTRY (find_tag_comment) );
      if( buffer[0] == '\0' )
	{
	  buffer[0]=' '; buffer[1]='\0';
	}
      strcpy( tag.comment, buffer );
    }
  else
    tag.comment[0]='\0';
  
  active = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON (find_buttons_year) );
  if( active )
    {
      buffer = gtk_entry_get_text( GTK_ENTRY (find_tag_year) );
      if( buffer[0] == '\0' )
	{
	  buffer[0]=' '; buffer[1]='\0';
	}
      strcpy( tag.year, buffer );
    }
  else
    tag.year[0]='\0';

  active = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON (find_buttons_genre) );
  if( active )
    {
      buffer = gtk_entry_get_text( GTK_ENTRY(GTK_COMBO(find_tag_genre)->entry));
      if( buffer[0] == '\0' )
	tag.genre=EOF;
      else
	for( i=0; i<GENRE_MAX; i++) 
	  { 
	    buffer2 = id3tag_genre_names[i];
	    if( (strcmp( buffer, buffer2))==0) 
	      { 
		tag.genre=i; 
		break;  
	      }  
	  } 
    }
  else
    tag.genre=EOF;
  
  id3tag_show(tag);

  find_display_results( );
    
  find_go( directory, directory, 0 , recursive, tag, NULL );
		       
  return(1);
}


void find_go( gchar *rootdir, gchar *dir, gint depth, gboolean recursive, struct id3tag tag, FILE *file )
{
  DIR *dp;
  struct dirent *entry;
  struct stat statbuf;
  struct id3tag tag2;
  gchar *buffer[2][2];
  
  if( (dp = opendir(dir))==NULL )
    {
      g_print("page_find.c, find_go: ERROR while opening %s!\n", dir);
      gnome_error_dialog( _("Could not open directory!") );
      return;
    }
  
  while( (entry = readdir(dp)) != NULL )
    {
      chdir(dir); 
      lstat( entry->d_name, &statbuf);
      if( S_ISDIR(statbuf.st_mode)) /* If it's a directory */
	{
	  /* Shall it be recursive ? */
	  if( recursive == 0 )
	    continue;
	  /* ignore "." and ".." */
	  if( strcmp(".", entry->d_name) == 0 || strcmp("..", entry->d_name) == 0 )
	    continue;
	  printf("%*s%s/\n", depth, " ", entry->d_name );
	  /* Recurse but increase the indent level */
	  find_go( rootdir, entry->d_name, depth+4, recursive, tag, file );
	}
      else /* If it's not a directory */
	{
	  printf("%*s%s\n", depth, " ", entry->d_name );
	  tag2 = id3tag_get( entry->d_name);
	  /* If the file has no valid tag */
	  if( strncmp( tag2.tag, "TAG", 3 ) != 0 )
	    {
	      printf("Skipped \"%s\". No valid tag!\n", entry->d_name );
	      continue;
	    }
	  
	  /* Found a matching TAG, add the filename to the list */
	  if( id3tag_cmp( tag, tag2 ) == 0 )
	    {
	      g_print("FOUND: %s in dir %s\n", entry->d_name, dir);
	      /* Add it to the list */
	      
	      if( strcmp( rootdir, dir) == 0 )
		buffer[0][0] = dir;
	      else
		buffer[0][0] = g_concat_dir_and_file( rootdir, dir );
	  
	      buffer[0][1] = entry->d_name;
	      gtk_clist_append( (GtkCList *) find_results_list, buffer[0] );
	    }
	}
    }

  chdir("..");
  closedir(dp);
}
