/* 	$Id: page_sort.c,v 1.7 2000/01/08 19:59:46 ben Exp $	 */

#include <gnome.h>

#include <stdio.h>
#include <unistd.h>
#include <dirent.h>
#include <string.h>
#include <sys/stat.h>
#include <stdlib.h>

#include "yamt.h"
#include "page_sort.h"


GtkWidget *sort_box_new( )
{
  GtkWidget *box;
  
  GtkWidget *sort_frame_directory;
  GtkWidget *sort_frame_format;
  
  GtkWidget *sort_table_directory;
  GtkWidget *sort_table_format;
  
  GtkWidget *sort_label_directory_source;
  GtkWidget *sort_label_directory_target;
  GtkWidget *sort_label_level1;
  GtkWidget *sort_label_level2;
  
  GtkWidget *sort_button_select_source;
  GtkWidget *sort_button_select_target;
  GtkWidget *sort_buttons_box;
  GtkWidget *sort_buttons_quit;
  GtkWidget *sort_buttons_start;

  
  /* The box it which everything is put */
  box = gtk_vbox_new( FALSE, 0);
  
  /* Frame for directory */
  sort_frame_directory = gtk_frame_new( NULL );
  gtk_box_pack_start( GTK_BOX (box), sort_frame_directory, TRUE, FALSE, 0 );
  gtk_widget_show( sort_frame_directory );

  /* Table for directory */
  sort_table_directory = gtk_table_new( 2, 2, TRUE);
  gtk_table_set_row_spacings( GTK_TABLE (sort_table_directory), 5);
  gtk_container_set_border_width( GTK_CONTAINER (sort_table_directory), 5);
  gtk_container_add( GTK_CONTAINER (sort_frame_directory), sort_table_directory ); 
  gtk_widget_show( sort_table_directory );
    
  /* The Source Directory */
  sort_label_directory_source=gtk_label_new("Source Directory: ");
  gtk_table_attach_defaults( GTK_TABLE (sort_table_directory), sort_label_directory_source, 0, 1, 0, 1);
  gtk_widget_show( sort_label_directory_source );

  sort_directory_source=gtk_label_new( prop_mp3_dir );
  gtk_table_attach_defaults( GTK_TABLE (sort_table_directory), sort_directory_source, 1, 2, 0, 1); 
  gtk_widget_show( sort_directory_source );
  
  /* The select button */
  sort_button_select_source = gnome_stock_or_ordinary_button( GNOME_STOCK_PIXMAP_OPEN );
  gtk_signal_connect( GTK_OBJECT (sort_button_select_source), "clicked", 
		      GTK_SIGNAL_FUNC (sort_directory_select), "Select Directory"); 
  gtk_table_attach_defaults( GTK_TABLE (sort_table_directory), sort_button_select_source, 2, 3, 0, 1); 
  gtk_widget_show( sort_button_select_source );

  /* The Target (Root) Directory */
  sort_label_directory_target=gtk_label_new("Target Directory: ");
  gtk_table_attach_defaults( GTK_TABLE (sort_table_directory), sort_label_directory_target, 0, 1, 1, 2);
  gtk_widget_show( sort_label_directory_target );

  sort_directory_target=gtk_label_new("[no dir selected]");
  gtk_table_attach_defaults( GTK_TABLE (sort_table_directory), sort_directory_target, 1, 2, 1, 2); 
  gtk_widget_show( sort_directory_target );
  
  /* The select button */
  sort_button_select_target = gnome_stock_or_ordinary_button( GNOME_STOCK_PIXMAP_OPEN );
  gtk_signal_connect( GTK_OBJECT (sort_button_select_target), "clicked", 
		      GTK_SIGNAL_FUNC (sort_directory_select2), "Select Directory"); 
  gtk_table_attach_defaults( GTK_TABLE (sort_table_directory), sort_button_select_target, 2, 3, 1, 2); 
  gtk_widget_show( sort_button_select_target );

  /* The recursive button */
  sort_button_recursive = gtk_check_button_new_with_label("Recurse Subdirs");
  gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON (sort_button_recursive), FALSE ); 
  gtk_table_attach_defaults( GTK_TABLE (sort_table_directory), sort_button_recursive, 1, 2, 2, 3);
  gtk_widget_show( sort_button_recursive );

  /* The format frame */
  sort_frame_format = gtk_frame_new( NULL );
  gtk_frame_set_label( GTK_FRAME (sort_frame_format), "Format");
  gtk_box_pack_start( GTK_BOX (box), sort_frame_format, TRUE, FALSE, 0 );
  gtk_widget_show( sort_frame_format );

  /* Table  */
  sort_table_format = gtk_table_new( 5, 3, TRUE);
  gtk_container_add( GTK_CONTAINER (sort_frame_format), sort_table_format ); 
  gtk_widget_show( sort_table_format );

  /* Label for level 1 */
  sort_label_level1 = gtk_label_new("Level 1:");
  gtk_table_attach_defaults( GTK_TABLE (sort_table_format), sort_label_level1, 0, 1, 0, 1); 
  gtk_widget_show( sort_label_level1);

  /* Create a new combo box */
  sort_level1 = gtk_combo_new();
  gtk_entry_set_editable( GTK_ENTRY (GTK_COMBO(sort_level1)->entry), FALSE);
  /* Create the CList */
  if ( !sort_level1_list )
    {
      sort_level1_list = g_list_append( sort_level1_list, "Artist" );
      sort_level1_list = g_list_append( sort_level1_list, "Album" );
      sort_level1_list = g_list_append( sort_level1_list, "Year" );
      sort_level1_list = g_list_append( sort_level1_list, "Genre" );
      sort_level1_list = g_list_append( sort_level1_list, "Comment" );
      sort_level1_list = g_list_append( sort_level1_list, "Title" );
    }
  /* Connect the combo and the list */
  gtk_combo_set_popdown_strings(GTK_COMBO(sort_level1), sort_level1_list);
  gtk_table_attach_defaults( GTK_TABLE (sort_table_format), sort_level1, 1, 2, 0, 1);
  gtk_widget_show(sort_level1);

  /* Label for level 2 */
  sort_label_level2 = gtk_label_new("Level 2:");
  gtk_table_attach_defaults( GTK_TABLE (sort_table_format), sort_label_level2, 0, 1, 2, 3); 
  gtk_widget_show( sort_label_level2);

  /* Create a new combo box */
  sort_level2 = gtk_combo_new();
  gtk_entry_set_editable( GTK_ENTRY (GTK_COMBO(sort_level2)->entry), FALSE);
  /* Create the CList */
  if ( !sort_level2_list )
    {
      sort_level2_list = g_list_append( sort_level2_list, "Album" );
      sort_level2_list = g_list_append( sort_level2_list, "Artist" );
      sort_level2_list = g_list_append( sort_level2_list, "Year" );
      sort_level2_list = g_list_append( sort_level2_list, "Genre" );
      sort_level2_list = g_list_append( sort_level2_list, "Comment" );
      sort_level2_list = g_list_append( sort_level2_list, "Title" );
    }
  /* Connect the combo and the list */
  gtk_combo_set_popdown_strings(GTK_COMBO(sort_level2), sort_level2_list);
  gtk_table_attach_defaults( GTK_TABLE (sort_table_format), sort_level2, 1, 2, 2, 3);
  gtk_widget_show(sort_level2);

  /* The Box for the buttons */
  sort_buttons_box = gtk_hbox_new( TRUE, 10);
  gtk_container_set_border_width( GTK_CONTAINER (sort_buttons_box), 3);
  gtk_box_pack_start( GTK_BOX (box), sort_buttons_box, TRUE, FALSE, 0 );
  gtk_widget_show( sort_buttons_box );

  /* The Buttons */
  sort_buttons_start = gnome_stock_or_ordinary_button( GNOME_STOCK_PIXMAP_EXEC );
  gtk_signal_connect( GTK_OBJECT (sort_buttons_start), "clicked", 
		      GTK_SIGNAL_FUNC (sort_start), NULL ); 
  gtk_box_pack_start( GTK_BOX (sort_buttons_box), sort_buttons_start, TRUE, TRUE, 0 );
  gtk_widget_show( sort_buttons_start );

  sort_buttons_quit = gnome_stock_or_ordinary_button( GNOME_STOCK_PIXMAP_QUIT );
  gtk_signal_connect( GTK_OBJECT (sort_buttons_quit), "clicked",
                      GTK_SIGNAL_FUNC (gtk_exit), NULL );
  gtk_box_pack_start( GTK_BOX (sort_buttons_box), sort_buttons_quit, TRUE, TRUE, 0 );
  gtk_widget_show( sort_buttons_quit );

  return(box);
}


void sort_directory_select( void )
{
  GtkWidget *filew;

  filew = gtk_file_selection_new("Select a Directory");

  gtk_signal_connect( GTK_OBJECT (filew), "destroy",
		      GTK_SIGNAL_FUNC (gtk_widget_destroy), filew);
  
  /* Connect the ok buton to load_file */
  gtk_signal_connect( GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), "clicked", 
 		      GTK_SIGNAL_FUNC (sort_lf), filew); 
  gtk_signal_connect( GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), "clicked",
		      GTK_SIGNAL_FUNC (destroy), filew);
  
  /* Connect the cancel  buton to destroy */  
  gtk_signal_connect( GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button), "clicked",
		      GTK_SIGNAL_FUNC (destroy), filew);
  
  gtk_widget_show(filew);
}

			      
/* I don't know how to pass the filename directly to load_file so I use this function */
void sort_lf( GtkWidget *widget, GtkFileSelection *file_selection )
{
  gchar *filename=gtk_file_selection_get_filename( GTK_FILE_SELECTION (file_selection));

  sort_directory_load( filename );
}


void sort_directory_load( gchar *dirname )
{
  gtk_label_set_text( GTK_LABEL (sort_directory_source),dirname);
  g_print("dir: %s\n", dirname );
}


void sort_directory_select2( void )
{
  GtkWidget *filew;

  filew = gtk_file_selection_new("Select a Directory");

  gtk_signal_connect( GTK_OBJECT (filew), "destroy",
		      GTK_SIGNAL_FUNC (gtk_widget_destroy), filew);
  
  /* Connect the ok buton to load_file */
  gtk_signal_connect( GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), "clicked", 
 		      GTK_SIGNAL_FUNC (sort_lf2), filew); 
  gtk_signal_connect( GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button), "clicked",
		      GTK_SIGNAL_FUNC (destroy), filew);
  
  /* Connect the cancel  buton to destroy */  
  gtk_signal_connect( GTK_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button), "clicked",
		      GTK_SIGNAL_FUNC (destroy), filew);
  
  gtk_widget_show(filew);
}

			      
/* I don't know how to pass the filename directly to load_file so I use this function */
void sort_lf2( GtkWidget *widget, GtkFileSelection *file_selection )
{
  gchar *filename=gtk_file_selection_get_filename( GTK_FILE_SELECTION (file_selection));

  sort_directory_load2( filename );
}


void sort_directory_load2( gchar *dirname )
{
  gtk_label_set_text( GTK_LABEL (sort_directory_target),dirname);
  g_print("dir: %s\n", dirname );
}


void sort_start( void )
{
  gchar *format_level1;
  gchar *format_level2;
  gchar *source_directory;
  gchar *target_directory;
  gboolean   recursive;
  
  g_print("Sort start!\n");

  format_level1 = gtk_entry_get_text( GTK_ENTRY (GTK_COMBO(sort_level1)->entry) );
  g_print("Format Level1: %s\n", format_level1);

  format_level2 = gtk_entry_get_text( GTK_ENTRY (GTK_COMBO(sort_level2)->entry) );
  g_print("Format Level2: %s\n", format_level2);

  gtk_label_get( GTK_LABEL (sort_directory_source), &source_directory );  
  g_print("(Root-)Directory: %s\n", source_directory);

  gtk_label_get( GTK_LABEL (sort_directory_target), &target_directory );  
  g_print("(Root-)Directory: %s\n", target_directory );

  if( (strcmp( target_directory, "[no dir selected]")) == 0 )
    target_directory = source_directory;

  recursive = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON (sort_button_recursive) );
  g_print("recursive: %i\n", recursive );

  sort_go( target_directory, source_directory, 0 , recursive, format_level1, format_level2);
}


void sort_go( gchar *rootdir, gchar *dir, gint depth, gboolean recursive, gchar *format_level1, gchar *format_level2 )
{
  DIR *dp;
  struct dirent *entry;
  struct stat statbuf;
  
  if( (dp = opendir(dir))==NULL )
    {
      g_print("ERROR while opening %s!\n", dir);
      gnome_error_dialog( _("Could not open directory!") );
      return;
    }
  
  while( (entry = readdir(dp)) != NULL )
    {
      chdir(dir); 
      lstat( entry->d_name, &statbuf);
      if( S_ISDIR(statbuf.st_mode)) /* If it's a directory */
	{
	  /* Shall it be recursive ? */
	  if( recursive == 0 )
	    continue;
	  /* ignore "." and ".." */
	  if( strcmp(".", entry->d_name) == 0 || strcmp("..", entry->d_name) == 0 )
	    continue;
	  printf("%*s%s/\n", depth, " ", entry->d_name );
	  /* Recurse but increase the indent level */
	  sort_go( rootdir, entry->d_name, depth+4, recursive, format_level1, format_level2 );
	}
      else /* If it's not a directory */
	{
	  printf("%*s%s\n", depth, " ", entry->d_name );
          id3tag_sort( entry->d_name, rootdir, format_level1, format_level2 );
	}
    }

  chdir("..");
  closedir(dp);
}
