/* 	$Id: properties.c,v 1.4 2000/01/08 20:26:43 ben Exp $	 */

#include <gnome.h>

#include "yamt.h"
#include "properties.h"


GtkWidget *properties_dir;
GtkWidget *properties_player;

void properties( void )
{
  GtkWidget *properties_window;
  GtkWidget *properties_box;

  GtkWidget *properties_frame;
  GtkWidget *properties_table;
  GtkWidget *properties_label;

  GtkWidget *properties_buttons_box;
  GtkWidget *properties_buttons_cancel;
  GtkWidget *properties_buttons_save;
  GtkWidget *properties_buttons_ok;
  
  gchar     *buffer;
  
  properties_window = gtk_window_new( GTK_WINDOW_TOPLEVEL );
  gtk_signal_connect( GTK_OBJECT (properties_window), "delete_event",
		      GTK_SIGNAL_FUNC (gtk_widget_destroy), NULL );

  /* Main box */
  properties_box = gtk_vbox_new( FALSE, 0);
  gtk_container_border_width( GTK_CONTAINER (properties_box), 1);
  gtk_container_add( GTK_CONTAINER (properties_window), properties_box);
  gtk_widget_show( properties_box );

  properties_frame = gtk_frame_new( _("Main") );
  gtk_box_pack_start( GTK_BOX (properties_box), properties_frame, TRUE, FALSE, 0 );  
  gtk_widget_show( properties_frame );

  properties_table = gtk_table_new( 2, 2, FALSE);
  gtk_container_set_border_width( GTK_CONTAINER (properties_table), 2); 
/*   gtk_table_set_row_spacings( GTK_TABLE (properties_table), 5 ); */
/*   gtk_table_set_col_spacings( GTK_TABLE (properties_table), 10 ); */
  gtk_container_add( GTK_CONTAINER (properties_frame), properties_table); 
  gtk_widget_show(properties_table);

  /* MP3 directory */  
  properties_label = gtk_label_new( _("Default Directory for mp3s:") );
  gtk_table_attach_defaults( GTK_TABLE (properties_table), properties_label, 0, 1, 0, 1);

  gtk_widget_show( properties_label );

  
  properties_dir = gtk_entry_new();
  gtk_table_attach_defaults( GTK_TABLE (properties_table), properties_dir, 1, 2, 0, 1);
  gtk_widget_show( properties_dir );

  buffer = getenv("HOME");
  gtk_entry_set_text( GTK_ENTRY (properties_dir), buffer );

  /* MP3 player */
  properties_label = gtk_label_new( _("Default MP3 Player:") );
  gtk_table_attach_defaults( GTK_TABLE (properties_table), properties_label, 0, 1, 1, 2);

  gtk_widget_show( properties_label );

  properties_player = gtk_entry_new();
  gtk_table_attach_defaults( GTK_TABLE (properties_table), properties_player, 1, 2, 1, 2);
  gtk_widget_show( properties_player );

  buffer = "xmms";
  gtk_entry_set_text( GTK_ENTRY (properties_player), buffer );

  /* Buttons */  
  properties_buttons_box = gtk_hbox_new( TRUE, 10);
  gtk_container_set_border_width( GTK_CONTAINER (properties_buttons_box), 5);
  gtk_box_pack_start( GTK_BOX (properties_box), properties_buttons_box, TRUE, FALSE, 0 );
  gtk_widget_show( properties_buttons_box );
  
  /* The Buttons */
  properties_buttons_cancel = gnome_stock_or_ordinary_button( GNOME_STOCK_PIXMAP_CLOSE );
  gtk_signal_connect( GTK_OBJECT (properties_buttons_cancel), "clicked", 
		      GTK_SIGNAL_FUNC (destroy), properties_window ); 
  gtk_box_pack_start( GTK_BOX (properties_buttons_box), properties_buttons_cancel, TRUE, TRUE, 0 );
  gtk_widget_show( properties_buttons_cancel );

  properties_buttons_save = gnome_stock_or_ordinary_button( GNOME_STOCK_PIXMAP_SAVE );
  gtk_signal_connect( GTK_OBJECT (properties_buttons_save), "clicked", 
		      GTK_SIGNAL_FUNC (properties_save), NULL ); 
  gtk_box_pack_start( GTK_BOX (properties_buttons_box), properties_buttons_save, TRUE, TRUE, 0 );
  gtk_widget_show( properties_buttons_save );

  properties_buttons_ok = gnome_stock_or_ordinary_button( "OK" );
  gtk_signal_connect( GTK_OBJECT (properties_buttons_ok), "clicked", 
		      GTK_SIGNAL_FUNC (properties_ok), properties_window ); 
  gtk_box_pack_start( GTK_BOX (properties_buttons_box), properties_buttons_ok, TRUE, TRUE, 0 );
  gtk_widget_show( properties_buttons_ok );

  properties_load();
  
  gtk_widget_show( properties_window );
}


void properties_load( void ) 
{
  gchar *buffer;
  gchar *buffer2;

  /* MP3 directory */
  buffer = gnome_config_get_string("yamt/main/dir");
  if( properties_dir != NULL )
    gtk_entry_set_text( GTK_ENTRY (properties_dir), buffer );
  if( buffer == NULL )
    buffer = getenv("HOME");
  g_print("Default mp3 directory: %s\n", buffer);
  prop_mp3_dir = buffer;

  /* MP3 player */
  buffer = gnome_config_get_string("yamt/main/player=xmms ");
  if( properties_player != NULL )
    gtk_entry_set_text( GTK_ENTRY (properties_player), buffer );
  g_print("Default mp3 player: %s\n", buffer);
  prop_mp3_player = buffer;
}


void properties_ok( GtkWidget *widget, gpointer *data)
{
  properties_save( );
  gtk_widget_destroy( GTK_WIDGET (data) );
}


void properties_save( void )
{
  gchar *buffer;

  /* MP3 directory */
  buffer = gtk_entry_get_text( GTK_ENTRY (properties_dir) );
  gnome_config_set_string("yamt/main/dir", buffer );

  /* MP3 player */
  buffer = gtk_entry_get_text( GTK_ENTRY (properties_player) );
  gnome_config_set_string("yamt/main/player", buffer );
  
  /* Write the config file */
  gnome_config_sync();
  /* Apply the changes */
  properties_load();
}
