/* 	$Id: yamt.c,v 1.5 2000/01/08 19:57:03 ben Exp $	 */

#include <gnome.h>

#include "yamt.h"
#include "page_edit.h"
#include "page_rename.h"
/* #include "page_mass.h"  */
/* #include "page_sort.h" */
#include "menus.h"


int main( int argc, char **argv )
{
  GtkWidget *main_vbox;
  GtkWidget *vbox_tag;
  GtkWidget *vbox_rename;
  GtkWidget *vbox_mass;
  GtkWidget *vbox_sort;
  GtkWidget *vbox_find;
  GtkWidget *label;
  
  mfile.filename[0]='\0';
  
  gnome_init( _("Yet Another Mp3 Tool"), _("0.2"), argc, argv);

  /* This creates the basic window */
  app = gnome_app_new( _("YAMT"), _("Yet Another Mp3 Tool") );
  gtk_signal_connect( GTK_OBJECT (app), "delete_event",
		      GTK_SIGNAL_FUNC (gtk_exit), NULL);

  /* The main vbox */
  main_vbox = gtk_vbox_new( FALSE, 0);
  gtk_container_border_width( GTK_CONTAINER (main_vbox), 1);
  /* I put the vbox into the app and everything else into the vbox */
  gnome_app_set_contents( GNOME_APP (app), main_vbox);

  
  /* Create the statusbar and show it */
/*   install_statusbar( app );  */
  
  /* Create the menubar and show it */
  install_menus( app );

  /* Read the yamt configuration file */
  properties_load();

  /**************************************** START OF NOTEBOOK ****************************************/
  /* The notebook itself */
  notebook=gtk_notebook_new();
  gtk_box_pack_start( GTK_BOX (main_vbox), notebook, FALSE, FALSE, 0);
  gtk_widget_show( notebook );
  
  /***************** Page 1: "Change the ID3 TAG of one file" *****************/
  label = gtk_label_new( _("Edit") ); 
  gtk_widget_show( label );   

  vbox_tag = edit_box_new();
  gtk_widget_show(vbox_tag);
  
  gtk_notebook_append_page( GTK_NOTEBOOK (notebook), vbox_tag, label );

  /***************** Page 2: "Rename fileas based on their ID3 TAG" *****************/
  label = gtk_label_new( _("Rename") );
  gtk_widget_show( label );   

  vbox_rename = rename_box_new();
  gtk_widget_show( vbox_rename ); 
  
  gtk_notebook_append_page( GTK_NOTEBOOK (notebook), vbox_rename, label );
  
  /***************** Page 3: "Mass set ID3 TAG" *****************/
  label = gtk_label_new( _("Mass") );
  gtk_widget_show( label );
  
  vbox_mass = mass_box_new(); 
  gtk_widget_show( vbox_mass );

  gtk_notebook_append_page( GTK_NOTEBOOK (notebook), vbox_mass, label );

  /***************** Page 4: "Sort MP3 Files" *****************/
  label = gtk_label_new( _("Sort") );
  gtk_widget_show( label );
  
  /* The vbox */
  vbox_sort = sort_box_new(); 
  gtk_widget_show( vbox_sort );

  gtk_notebook_append_page( GTK_NOTEBOOK (notebook), vbox_sort, label );
  
  /***************** Page 4: "Find MP3 Files" *****************/
  label = gtk_label_new( _("Find") );
  gtk_widget_show( label );
  
  /* The vbox */
  vbox_find = find_box_new(); 
  gtk_widget_show( vbox_find );

  gtk_notebook_append_page( GTK_NOTEBOOK (notebook), vbox_find, label );
  
  /**************************************** END OF NOTEBOOK ****************************************/

  /* TEMP ??? */
/*   gtk_notebook_set_page( notebook, 3 );   */
  /* TEMP ??? */
  
  gtk_widget_show( app );

  /* If there was an argument use this as a filename and try to open it */
  if ( argc > 1 ) 
    edit_file_load( argv[1] );
  
  gtk_main();

  return(1);
}
